# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' @templateVar .FUN accuracy
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
accuracy.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_accuracy`, actual, predicted)
}

#' @templateVar .FUN weighted.accuracy
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.accuracy.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_accuracy`, actual, predicted, w)
}

#' @templateVar .FUN accuracy
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
accuracy.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_accuracy`, x)
}

#' @templateVar .FUN baccuracy
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @param adjust A <[logical]> value (default: [FALSE]). If [TRUE] the metric is adjusted for random chance \eqn{\frac{1}{k}}.
#'
#' @export
baccuracy.factor <- function(actual, predicted, adjust = FALSE, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_balanced_accuracy`, actual, predicted, adjust, na_rm = na.rm)
}

#' @templateVar .FUN weighted.baccuracy
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @param adjust A <[logical]> value (default: [FALSE]). If [TRUE] the metric is adjusted for random chance \eqn{\frac{1}{k}}.
#'
#' @export
weighted.baccuracy.factor <- function(actual, predicted, w, adjust = FALSE, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_balanced_accuracy`, actual, predicted, w, adjust, na_rm = na.rm)
}

#' @templateVar .FUN baccuracy
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @param adjust A <[logical]> value (default: [FALSE]). If [TRUE] the metric is adjusted for random chance \eqn{\frac{1}{k}}.
#'
#' @export
baccuracy.cmatrix <- function(x, adjust = FALSE, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_balanced_accuracy`, x, adjust, na_rm = na.rm)
}

#' @templateVar .FUN brier.score
#' @templateVar .METHOD matrix
#' @template classification_proper_inherit
#' @export
brier.score.matrix <- function(ok, qk, ...) {
    .Call(`_SLmetrics_brier_score`, ok, qk)
}

#' @templateVar .FUN weighted.brier.score
#' @templateVar .METHOD matrix
#' @template classification_proper_inherit
#' @export
weighted.brier.score.matrix <- function(ok, qk, w, ...) {
    .Call(`_SLmetrics_weighted_brier_score`, ok, qk, w)
}

#' @templateVar .FUN ckappa
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @param beta A <[double]> value of [length] 1 (default: 0). If \eqn{\beta \neq 0} the off-diagonals of the confusion matrix are penalized with a factor of \eqn{(y_{+} - y_{i,-})^\beta}.
#'
#' @export
ckappa.factor <- function(actual, predicted, beta = 0.0, ...) {
    .Call(`_SLmetrics_cohens_kappa`, actual, predicted, beta)
}

#' @templateVar .FUN weighted.ckappa
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @param beta A <[double]> value of [length] 1 (default: 0). If \eqn{\beta \neq 0} the off-diagonals of the confusion matrix are penalized with a factor of \eqn{(y_{+} - y_{i,-})^\beta}.
#'
#' @export
weighted.ckappa.factor <- function(actual, predicted, w, beta = 0.0, ...) {
    .Call(`_SLmetrics_weighted_cohens_kappa`, actual, predicted, w, beta)
}

#' @templateVar .FUN ckappa
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @param beta A <[double]> value of [length] 1 (default: 0). If \eqn{\beta \neq 0} the off-diagonals of the confusion matrix are penalized with a factor of \eqn{(y_{+} - y_{i,-})^\beta}.
#'
#' @export
ckappa.cmatrix <- function(x, beta = 0.0, ...) {
    .Call(`_SLmetrics_cmatrix_cohens_kappa`, x, beta)
}

#' @templateVar .FUN cmatrix
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
cmatrix.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_confusion_matrix`, actual, predicted)
}

#' @templateVar .FUN weighted.cmatrix
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.cmatrix.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_confusion_matrix`, actual, predicted, w)
}

#' @templateVar .FUN cross.entropy
#' @templateVar .METHOD matrix
#' @template classification_entropy_inherit
#' @export
cross.entropy.matrix <- function(pk, qk, dim = 0L, normalize = FALSE, ...) {
    .Call(`_SLmetrics_cross_entropy`, pk, qk, dim, normalize)
}

#' @templateVar .FUN dor
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
dor.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_diagnostic_odds_ratio`, actual, predicted)
}

#' @templateVar .FUN weighted.dor
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.dor.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_diagnostic_odds_ratio`, actual, predicted, w)
}

#' @templateVar .FUN dor
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
dor.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_diagnostic_odds_ratio`, x)
}

#' @templateVar .FUN fbeta
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @param beta A <[double]> vector of [length] \eqn{1} (default: \eqn{1}).
#'
#' @export
fbeta.factor <- function(actual, predicted, beta = 1.0, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_fbeta_score`, actual, predicted, beta, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.fbeta
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @param beta A <[double]> vector of [length] \eqn{1} (default: \eqn{1}).
#'
#' @export
weighted.fbeta.factor <- function(actual, predicted, w, beta = 1.0, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_fbeta_score`, actual, predicted, w, beta, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fbeta
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @param beta A <[double]> vector of [length] \eqn{1} (default: \eqn{1}).
#'
#' @export
fbeta.cmatrix <- function(x, beta = 1.0, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_fbeta_score`, x, beta, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fdr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
fdr.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_false_discovery_rate`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.fdr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.fdr.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_false_discovery_rate`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fdr
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
fdr.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_false_discovery_rate`, x, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fer
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
fer.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_false_omission_rate`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.fer
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.fer.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_false_omission_rate`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fer
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
fer.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_false_omission_rate`, x, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fpr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
fpr.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_false_positive_rate`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.fpr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.fpr.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_false_positive_rate`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fpr
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
fpr.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_false_positive_rate`, x, estimator, na_rm = na.rm)
}

#' @method fallout factor
#' @export
fallout.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_fallout`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.fallout factor
#' @export
weighted.fallout.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_fallout`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method fallout cmatrix
#' @export
fallout.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_fallout`, x, estimator, na_rm = na.rm)
}

#' @templateVar .FUN fmi
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
fmi.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_fowlkes_mallows_index`, actual, predicted)
}

#' @templateVar .FUN weighted.fmi
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.fmi.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_fowlkes_mallows_index`, actual, predicted, w)
}

#' @templateVar .FUN fmi
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
fmi.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_fowlkes_mallows_index`, x)
}

#' @templateVar .FUN hammingloss
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
hammingloss.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_hamming_loss`, actual, predicted)
}

#' @templateVar .FUN weighted.hammingloss
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.hammingloss.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_hamming_loss`, actual, predicted, w)
}

#' @templateVar .FUN hammingloss
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
hammingloss.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_hamming_loss`, x)
}

#' @templateVar .FUN jaccard
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
jaccard.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_jaccard_score`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.jaccard
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.jaccard.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_jaccard_score`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN jaccard
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
jaccard.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_jaccard_score`, x, estimator, na_rm = na.rm)
}

#' @method csi factor
#' @export
csi.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_critical_success_index`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.csi factor
#' @export
weighted.csi.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_critical_success_index`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method csi cmatrix
#' @export
csi.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_critical_success_index`, x, estimator, na_rm = na.rm)
}

#' @method tscore factor
#' @export
tscore.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_threat_score`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.tscore factor
#' @export
weighted.tscore.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_threat_score`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method tscore cmatrix
#' @export
tscore.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_threat_score`, x, estimator, na_rm = na.rm)
}

#' @templateVar .FUN logloss
#' @templateVar .METHOD factor
#' @template classification_entropy_inherit
#' @export
logloss.factor <- function(actual, response, normalize = TRUE, ...) {
    .Call(`_SLmetrics_LogLoss`, actual, response, normalize)
}

#' @templateVar .FUN weighted.logloss
#' @templateVar .METHOD factor
#' @template classification_entropy_inherit
#' @export
weighted.logloss.factor <- function(actual, response, w, normalize = TRUE, ...) {
    .Call(`_SLmetrics_weighted_LogLoss`, actual, response, w, normalize)
}

#' @templateVar .FUN mcc
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
mcc.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_mcc`, actual, predicted)
}

#' @templateVar .FUN weighted.mcc
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.mcc.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_mcc`, actual, predicted, w)
}

#' @templateVar .FUN mcc
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
mcc.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_mcc`, x)
}

#' @method phi factor
#' @export
phi.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_phi_coefficient`, actual, predicted)
}

#' @method weighted.phi factor
#' @export
weighted.phi.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_phi_coefficient`, actual, predicted, w)
}

#' @method phi cmatrix
#' @export
phi.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_phi_coefficient`, x)
}

#' @templateVar .FUN nlr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
nlr.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_negative_likelihood_ratio`, actual, predicted)
}

#' @templateVar .FUN weighted.nlr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.nlr.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_negative_likelihood_ratio`, actual, predicted, w)
}

#' @templateVar .FUN nlr
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
nlr.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_negative_likelihood_ratio`, x)
}

#' @templateVar .FUN npv
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
npv.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_negative_predictive_value`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.npv
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.npv.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_negative_predictive_value`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN npv
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
npv.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_negative_predictive_value`, x, estimator, na_rm = na.rm)
}

#' @templateVar .FUN plr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
plr.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_positive_likelihood_ratio`, actual, predicted)
}

#' @templateVar .FUN weighted.plr
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.plr.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_positive_likelihood_ratio`, actual, predicted, w)
}

#' @templateVar .FUN plr
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
plr.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_positive_likelihood_ratio`, x)
}

#' @templateVar .FUN precision
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
precision.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_precision`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.precision
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.precision.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_precision`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN precision
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
precision.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_precision`, x, estimator, na_rm = na.rm)
}

#' @method ppv factor
#' @export
ppv.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_ppv`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.ppv factor
#' @export
weighted.ppv.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_ppv_score`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method ppv cmatrix
#' @export
ppv.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_ppv_score`, x, estimator, na_rm = na.rm)
}

#' @templateVar .TITLE Precision-Recall Curve
#' @templateVar .FUN pr.curve
#' @templateVar .TYPE pr.curve
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
pr.curve.factor <- function(actual, response, thresholds = NULL, indices = NULL, ...) {
    .Call(`_SLmetrics_precision_recall_curve`, actual, response, thresholds, indices)
}

#' @templateVar .TITLE Precision-Recall Curve
#' @templateVar .FUN weighted.pr.curve
#' @templateVar .TYPE pr.curve
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
weighted.pr.curve.factor <- function(actual, response, w, thresholds = NULL, indices = NULL, ...) {
    .Call(`_SLmetrics_weighted_precision_recall_curve`, actual, response, w, thresholds, indices)
}

#' @templateVar .TITLE Area under the Precision-Recall Curve
#' @templateVar .FUN auc.pr.curve
#' @templateVar .TYPE auc
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
auc.pr.curve.factor <- function(actual, response, estimator = 0L, method = 0L, indices = NULL, ...) {
    .Call(`_SLmetrics_precision_recall_auc`, actual, response, estimator, method, indices)
}

#' @templateVar .TITLE Area under the Precision-Recall Curve
#' @templateVar .FUN weighted.auc.pr.curve
#' @templateVar .TYPE auc
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
weighted.auc.pr.curve.factor <- function(actual, response, w, estimator = 0L, method = 0L, indices = NULL, ...) {
    .Call(`_SLmetrics_precision_recall_auc_weighted`, actual, response, w, estimator, method, indices)
}

#' @templateVar .FUN recall
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
recall.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_recall_score`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.recall
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.recall.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_recall_score`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN recall
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
recall.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_recall_score`, x, estimator, na_rm = na.rm)
}

#' @method sensitivity factor
#' @export
sensitivity.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_sensitivity_score`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.sensitivity factor
#' @export
weighted.sensitivity.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_sensitivity_score`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method sensitivity cmatrix
#' @export
sensitivity.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_sensitivity_score`, x, estimator, na_rm = na.rm)
}

#' @method tpr factor
#' @export
tpr.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_true_positive_rate`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.tpr factor
#' @export
weighted.tpr.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_true_positive_rate`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method tpr cmatrix
#' @export
tpr.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_true_positive_rate`, x, estimator, na_rm = na.rm)
}

#' @templateVar .TITLE Receiver Operator Characteristics Curve
#' @templateVar .FUN roc.curve
#' @templateVar .TYPE roc.curve
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
roc.curve.factor <- function(actual, response, thresholds = NULL, indices = NULL, ...) {
    .Call(`_SLmetrics_roc_curve_unweighted`, actual, response, thresholds, indices)
}

#' @templateVar .TITLE Receiver Operator Characteristics Curve
#' @templateVar .FUN weighted.roc.curve
#' @templateVar .TYPE roc.curve
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
weighted.roc.curve.factor <- function(actual, response, w, thresholds = NULL, indices = NULL, ...) {
    .Call(`_SLmetrics_roc_curve_weighted`, actual, response, w, thresholds, indices)
}

#' @templateVar .TITLE Area under the ROC curve
#' @templateVar .FUN auc.roc.curve
#' @templateVar .TYPE auc
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
auc.roc.curve.factor <- function(actual, response, estimator = 0L, method = 0L, indices = NULL, ...) {
    .Call(`_SLmetrics_roc_auc`, actual, response, estimator, method, indices)
}

#' @templateVar .TITLE Area under the ROC curve
#' @templateVar .FUN weighted.auc.roc.curve
#' @templateVar .TYPE auc
#' @templateVar .METHOD factor
#' @template classification_auc_inherit
#' @export
weighted.auc.roc.curve.factor <- function(actual, response, w, estimator = 0L, method = 0L, indices = NULL, ...) {
    .Call(`_SLmetrics_roc_auc_weighted`, actual, response, w, estimator, method, indices)
}

#' @templateVar .FUN relative.entropy
#' @templateVar .METHOD matrix
#' @template classification_entropy_inherit
#' @export
relative.entropy.matrix <- function(pk, qk, dim = 0L, normalize = FALSE, ...) {
    .Call(`_SLmetrics_relative_entropy`, pk, qk, dim, normalize)
}

#' @templateVar .FUN shannon.entropy
#' @templateVar .METHOD matrix
#' @template classification_entropy_inherit
#' @export
shannon.entropy.matrix <- function(pk, dim = 0L, normalize = FALSE, ...) {
    .Call(`_SLmetrics_shannon_entropy`, pk, dim, normalize)
}

#' @templateVar .FUN specificity
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
specificity.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_specificity`, actual, predicted, estimator, na_rm = na.rm)
}

#' @templateVar .FUN weighted.specificity
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.specificity.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_specificity`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @templateVar .FUN specificity
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
specificity.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_specificity`, x, estimator, na_rm = na.rm)
}

#' @method tnr factor
#' @export
tnr.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_true_negative_rate`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.tnr factor
#' @export
weighted.tnr.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_true_negative_rate`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method tnr cmatrix
#' @export
tnr.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_true_negative_rate`, x, estimator, na_rm = na.rm)
}

#' @method selectivity factor
#' @export
selectivity.factor <- function(actual, predicted, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_selectivity`, actual, predicted, estimator, na_rm = na.rm)
}

#' @method weighted.selectivity factor
#' @export
weighted.selectivity.factor <- function(actual, predicted, w, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_weighted_selectivity`, actual, predicted, w, estimator, na_rm = na.rm)
}

#' @method selectivity cmatrix
#' @export
selectivity.cmatrix <- function(x, estimator = 0L, na.rm = TRUE, ...) {
    .Call(`_SLmetrics_cmatrix_selectivity`, x, estimator, na_rm = na.rm)
}

#' @templateVar .FUN zerooneloss
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
zerooneloss.factor <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_zero_one_loss`, actual, predicted)
}

#' @templateVar .FUN weighted.zerooneloss
#' @templateVar .METHOD factor
#' @template classification_standard_inherit
#'
#' @export
weighted.zerooneloss.factor <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_zero_one_loss`, actual, predicted, w)
}

#' @templateVar .FUN zerooneloss
#' @templateVar .METHOD cmatrix
#' @template classification_standard_inherit
#'
#' @export
zerooneloss.cmatrix <- function(x, ...) {
    .Call(`_SLmetrics_cmatrix_zero_one_loss`, x)
}

#' @templateVar .FUN logloss
#' @templateVar .METHOD integer
#' @template classification_entropy_inherit
#' @export
logloss.integer <- function(actual, response, normalize = TRUE, ...) {
    .Call(`_SLmetrics_PoissonLogLoss`, actual, response, normalize)
}

#' @templateVar .FUN weighted.logloss
#' @templateVar .METHOD integer
#' @template classification_entropy_inherit
#' @export
weighted.logloss.integer <- function(actual, response, w, normalize = TRUE, ...) {
    .Call(`_SLmetrics_weighted_PoissonLogLoss`, actual, response, w, normalize)
}

#' @templateVar .FUN rsq
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
rsq.numeric <- function(actual, predicted, k = 0.0, ...) {
    .Call(`_SLmetrics_rsq`, actual, predicted, k)
}

#' @templateVar .FUN weighted.rsq
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.rsq.numeric <- function(actual, predicted, w, k = 0.0, ...) {
    .Call(`_SLmetrics_weighted_rsq`, actual, predicted, w, k)
}

#' @templateVar .FUN ccc
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
ccc.numeric <- function(actual, predicted, correction = FALSE, ...) {
    .Call(`_SLmetrics_ccc`, actual, predicted, correction)
}

#' @templateVar .FUN weighted.ccc
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.ccc.numeric <- function(actual, predicted, w, correction = FALSE, ...) {
    .Call(`_SLmetrics_weighted_ccc`, actual, predicted, w, correction)
}

#' @templateVar .FUN deviance.gamma
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @rawNamespace S3method(deviance.gamma,numeric)
deviance.gamma.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_gamma_deviance`, actual, predicted)
}

#' @templateVar .FUN weighted.deviance.gamma
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @rawNamespace S3method(weighted.deviance.gamma,numeric)
weighted.deviance.gamma.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_gamma_deviance`, actual, predicted, w)
}

#' @templateVar .FUN gmse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
gmse.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_gmse`, actual, predicted)
}

#' @templateVar .FUN weighted.gmse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.gmse.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_gmse`, actual, predicted, w)
}

#' @templateVar .FUN huberloss
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
huberloss.numeric <- function(actual, predicted, delta = 1.0, ...) {
    .Call(`_SLmetrics_huberloss`, actual, predicted, delta)
}

#' @templateVar .FUN weighted.huberloss
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.huberloss.numeric <- function(actual, predicted, w, delta = 1.0, ...) {
    .Call(`_SLmetrics_weighted_huberloss`, actual, predicted, w, delta)
}

#' @templateVar .FUN mae
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
mae.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_mae`, actual, predicted)
}

#' @templateVar .FUN weighted.mae
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.mae.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_mae`, actual, predicted, w)
}

#' @templateVar .FUN mape
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
mape.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_mape`, actual, predicted)
}

#' @templateVar .FUN weighted.mape
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.mape.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_mape`, actual, predicted, w)
}

#' @templateVar .FUN maape
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
maape.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_maape`, actual, predicted)
}

#' @templateVar .FUN weighted.maape
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.maape.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_maape`, actual, predicted, w)
}

#' @templateVar .FUN mpe
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
mpe.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_mpe`, actual, predicted)
}

#' @templateVar .FUN weighted.mpe
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.mpe.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_mpe`, actual, predicted, w)
}

#' @templateVar .FUN mse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
mse.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_mse`, actual, predicted)
}

#' @templateVar .FUN weighted.mse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.mse.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_mse`, actual, predicted, w)
}

#' @templateVar .FUN pinball
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
pinball.numeric <- function(actual, predicted, alpha = 0.5, deviance = FALSE, ...) {
    .Call(`_SLmetrics_pinball`, actual, predicted, alpha, deviance)
}

#' @templateVar .FUN weighted.pinball
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.pinball.numeric <- function(actual, predicted, w, alpha = 0.5, deviance = FALSE, ...) {
    .Call(`_SLmetrics_weighted_pinball`, actual, predicted, w, alpha, deviance)
}

#' @templateVar .FUN deviance.poisson
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @rawNamespace S3method(deviance.poisson,numeric)
deviance.poisson.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_poisson_deviance`, actual, predicted)
}

#' @templateVar .FUN weighted.deviance.poisson
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @rawNamespace S3method(weighted.deviance.poisson,numeric)
weighted.deviance.poisson.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_poisson_deviance`, actual, predicted, w)
}

#' @templateVar .FUN rae
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
rae.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_rae`, actual, predicted)
}

#' @templateVar .FUN weighted.rae
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.rae.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_rae`, actual, predicted, w)
}

#' @templateVar .FUN rrmse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
rrmse.numeric <- function(actual, predicted, normalization = 1L, ...) {
    .Call(`_SLmetrics_RelativeRootMeanSquaredError`, actual, predicted, normalization)
}

#' @templateVar .FUN weighted.rrmse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.rrmse.numeric <- function(actual, predicted, w, normalization = 1L, ...) {
    .Call(`_SLmetrics_weighted_RelativeRootMeanSquaredError`, actual, predicted, w, normalization)
}

#' @templateVar .FUN rmse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
rmse.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_rmse`, actual, predicted)
}

#' @templateVar .FUN weighted.rmse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.rmse.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_rmse`, actual, predicted, w)
}

#' @templateVar .FUN rmsle
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
rmsle.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_rmsle`, actual, predicted)
}

#' @templateVar .FUN weighted.rmsle
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.rmsle.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_rmsle`, actual, predicted, w)
}

#' @templateVar .FUN rrse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
rrse.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_rrse`, actual, predicted)
}

#' @templateVar .FUN weighted.rrse
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.rrse.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_rrse`, actual, predicted, w)
}

#' @templateVar .FUN smape
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
smape.numeric <- function(actual, predicted, ...) {
    .Call(`_SLmetrics_smape`, actual, predicted)
}

#' @templateVar .FUN weighted.smape
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @export
weighted.smape.numeric <- function(actual, predicted, w, ...) {
    .Call(`_SLmetrics_weighted_smape`, actual, predicted, w)
}

#' @templateVar .FUN deviance.tweedie
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @rawNamespace S3method(deviance.tweedie,numeric)
deviance.tweedie.numeric <- function(actual, predicted, power = 2.0, ...) {
    .Call(`_SLmetrics_tweedie_deviance`, actual, predicted, power)
}

#' @templateVar .FUN weighted.deviance.tweedie
#' @templateVar .METHOD numeric
#' @template regression_standard_inherit
#' @rawNamespace S3method(weighted.deviance.tweedie,numeric)
weighted.deviance.tweedie.numeric <- function(actual, predicted, w, power = 2.0, ...) {
    .Call(`_SLmetrics_weighted_tweedie_deviance`, actual, predicted, w, power)
}

#' @title Area under the curve
#'
#' @rdname tools_auc.xy.numeric
#' @method auc.xy numeric
#'
#' @param y,x A pair of <[double]> vectors of [length] \eqn{n}.
#' @param method A <[integer]> value (default: \eqn{0}). Defines the underlying method of calculating the area under the curve. If \eqn{0} it is calculated using the `trapezoid`-method, if \eqn{1} it is calculated using the `step`-method.
#' @param presorted A <[logical]>-value [length] 1 (default: [FALSE]). If [TRUE] the input will not be sorted by threshold.
#' @param ... Arguments passed into other methods.
#'
#' @export
auc.xy.numeric <- function(y, x, method = 0L, presorted = TRUE, ...) {
    .Call(`_SLmetrics_auc`, y, x, method, presorted)
}

.openmp_available <- function() {
    .Call(`_SLmetrics_openmp_available`)
}

.enable_openmp <- function() {
    .Call(`_SLmetrics_enable_openmp`)
}

.disable_openmp <- function() {
    .Call(`_SLmetrics_disable_openmp`)
}

.available_threads <- function() {
    .Call(`_SLmetrics_available_threads`)
}

.use_threads <- function(value = -1L) {
    .Call(`_SLmetrics_use_threads`, value)
}

#' @returns NULL
#'
#' @templateVar .FUN presort
#' @templateVar .METHOD matrix
#' @template utils_ordering_inherit
#'
#' @export
presort.matrix <- function(x, decreasing = FALSE, ...) {
    .Call(`_SLmetrics_sort_matrix`, x, decreasing)
}

#' @returns NULL
#' @templateVar .FUN preorder
#' @templateVar .METHOD matrix
#' @template utils_ordering_inherit
#'
#' @export
preorder.matrix <- function(x, decreasing = FALSE, ...) {
    .Call(`_SLmetrics_order_matrix`, x, decreasing)
}

