% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_BanknoteAuthentifcation.R
\docType{data}
\name{banknote}
\alias{banknote}
\title{Banknote authentication dataset}
\format{
A list with two components:
\describe{
\item{features}{A data frame with 4 variables: \code{variance}, \code{skewness},
\code{curtosis}, and \code{entropy}.}
\item{target}{A factor with levels \code{"inauthentic"} and \code{"authentic"}
representing the banknote's authenticity.}
}
}
\usage{
data(banknote)
}
\description{
This dataset contains features extracted from the wavelet transform of banknote
images, which are used to classify banknotes as authentic or inauthentic. The data
originates from the UCI Machine Learning Repository.

The data is provided as a list with two components:

\describe{
\item{features}{A data frame containing the following variables:
\describe{
\item{variance}{Variance of the wavelet transformed image.}
\item{skewness}{Skewness of the wavelet transformed image.}
\item{curtosis}{Curtosis of the wavelet transformed image.}
\item{entropy}{Entropy of the image.}
}
}
\item{target}{A factor indicating the authenticity of the banknote. The factor has
two levels:
\describe{
\item{inauthentic}{Indicates the banknote is not genuine.}
\item{authentic}{Indicates the banknote is genuine.}
}
}
}
}
\references{
Gillich, Eugen & Lohweg, Volker. (2010). Banknote Authentication.
}
\keyword{datasets}
